> For the complete documentation index, see [llms.txt](https://docs.warpstream.com/warpstream/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.warpstream.com/warpstream/reference/api-reference/virtual-clusters/create-a-multi-region-cluster.md).

# Create a Multi-Region Cluster

Valid virtual cluster types: `byoc`

A new agent key is automatically created with every new virtual cluster. The agent key is included in the response to this endpoint.

## Request

{% code overflow="wrap" %}

```bash
curl https://console.warpstream.com/api/v1/create_virtual_cluster \
-H "warpstream-api-key: XXXXXXXXXX" \  
-H "Content-Type: application/json" \
-d '{
    "virtual_cluster_name": "my-mrc-cluster",
    "virtual_cluster_type": "byoc",
    "virtual_cluster_region_group": "multiregion_us1",
    "virtual_cluster_cloud_provider": "aws",
    "virtual_cluster_tier": "enterprise"
  }'
```

{% endcode %}

## Response

```json
{
    "virtual_cluster_id": "vci_1d4930d7_8e6d_4ad9_b27a_654ed4aaa3ee",
    "virtual_cluster_name": "XXXXXXXXXX",
    "agent_pool_id": "api_417d3bf3_026d_4261_bb16_fe59a4262757",
    "agent_pool_name": "apn_XXXXXXXXXX",
    "agent_key": {
        "id":"aki_007f0341_3ab3_457a_a513_2b2c9415582f",
        "name": "akn_virtual_cluster_XXXXXXXXX_44c7ee374113",
        "key":"aks_a51b1fb20ac4a3af549503bb08cd309672fcada1030c5a494850e87ce5d4c613",
        "created_at":"2024-05-02T18:54:48.990229Z",
        "access_grants": [{
            "principal_kind": "agent",
            "resource_kind":"virtual_cluster",
            "resource_id":"vci_1d4930d7_8e6d_4ad9_b27a_654ed4aaa3ee"
        }]
    },
    "bootstrap.servers": "api_417d3bf3_026d_4261_bb16_fe59a4262757.groupdefault.kafka.discoveryv2.prod-z.us-east-1.warpstream.com:9092,api_417d3bf3_026d_4261_bb16_fe59a4262757.groupdefault.kafka.discoveryv2.prod-x.us-west-2.warpstream.com:9092"
}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.warpstream.com/warpstream/reference/api-reference/virtual-clusters/create-a-multi-region-cluster.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
